
QGIS Application - Bug report #8473

Cannot rename layers in composer legend

2013-08-15 07:14 PM - Giovanni Manghi

Status: Closed

Priority: Severe/Regression

Assignee: Marco Hugentobler

Category: Map Composer/Printing

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:Yes Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 17241

Description

It seems a regression: in the print composer legend the name of rasters/wms layers cannot be changed. The dialog shows, it allows enter

a new name but the operation has no effect. Works ok on 1.8.

History

#1 - 2013-08-15 07:20 PM - Giovanni Manghi

- File 12.png added

- File 22.png added

- File 11.png added

I see another issue, this time only on Linux. See Attached screenshots.

On Windows if in the composer legend there is vector with "single symbol" symbology, then the (one) symbology class has no text associated, but this can

be edited.

On Linux in the same situation, the (one) symbology class is given the layer name by default, and this cannot be edited.

#2 - 2013-08-16 02:48 AM - Salvatore Larosa

I am not fairly sure but this patch has worked for me (please anyone who knows better the composer code might reviews  it ?):

diff --git a/src/app/composer/qgscomposerlegendwidget.cpp b/src/app/composer/qgscomposerlegendwidget.cpp

index 613d394..5032ab7 100644

--- a/src/app/composer/qgscomposerlegendwidget.cpp

+++ b/src/app/composer/qgscomposerlegendwidget.cpp

@@ -740,8 +740,8 @@ void QgsComposerLegendWidget::on_mEditPushButton_clicked()

   QgsComposerLegendItemDialog itemDialog( currentItem );

   if ( itemDialog.exec() == QDialog::Accepted )

   {

-    currentItem->setUserText( itemDialog.itemText() );

-    mLegend->model()->updateItemText( currentItem );

+    currentItem->setText( itemDialog.itemText() );

+    //mLegend->model()->updateItemText( currentItem );

   }

   mLegend->beginCommand( tr( "Legend item edited" ) );
#3 - 2013-08-16 02:49 AM - Giovanni Manghi

- Pull Request or Patch supplied changed from No to Yes

#4 - 2013-08-18 02:32 PM - Anita Graser

- Subject changed from Cannot rename raster layers in composer legend to Cannot rename (raster) layers in composer legend

For me, this issue is not limited to raster layers. (Using today's OSGeo4W nightly - code rev 4408a8b.)

In a project with only one polygon layer, I can only rename the upper level item in the print composer legend - but not the sub-level item.

#5 - 2013-08-19 03:39 AM - Giovanni Manghi

- Subject changed from Cannot rename (raster) layers in composer legend to Cannot rename layers in composer legend

#6 - 2013-08-19 06:23 AM - René-Luc ReLuc

- Assignee set to René-Luc ReLuc

Thanks Salvatore for your patch, but it changes the way to manage text for all the layers and not only for raster layers.

I proposed this patch :

index 29b86f5..d958676 100644

--- a/src/core/composer/qgslegendmodel.cpp

+++ b/src/core/composer/qgslegendmodel.cpp

@@ -380,10 +380,9 @@ void QgsLegendModel::updateLayer( QStandardItem* layerItem )

     QgsMapLayer* mapLayer = QgsMapLayerRegistry::instance()->mapLayer( lItem->layerID() );

     if ( mapLayer )

     {

-      QgsVectorLayer* vLayer = qobject_cast<QgsVectorLayer*>( mapLayer );

-

       updateLayerItemText( lItem );

+      QgsVectorLayer* vLayer = qobject_cast<QgsVectorLayer*>( mapLayer );

       if ( vLayer )

       {

         addVectorLayerItemsV2( lItem, vLayer );

@@ -406,11 +405,9 @@ void QgsLegendModel::updateLayerItemText( QStandardItem* layerItem )

   QgsMapLayer* mapLayer = QgsMapLayerRegistry::instance()->mapLayer( lItem->layerID() );

   if ( !mapLayer ) return;

-  QgsVectorLayer* vLayer = qobject_cast<QgsVectorLayer*>( mapLayer );

-  if ( !vLayer ) return;

-

   QString label = lItem->userText().isEmpty() ? mapLayer->name() : lItem->userText();

+  QgsVectorLayer* vLayer = qobject_cast<QgsVectorLayer*>( mapLayer );

   if ( vLayer && lItem->showFeatureCount() )

   {

     label += QString( " [%1]" ).arg( vLayer->featureCount() );
#7 - 2013-08-19 10:44 AM - Salvatore Larosa

Hi René, sadly I am not a C++ expert :-( so my patch might not be correct.

Anyway, I did try your patch but renaming sub-level has not worked for me, I see the same issue as Anita.

For raster layers works fine!

Thanks.

#8 - 2013-08-20 05:22 AM - René-Luc ReLuc

- % Done changed from 0 to 90

I have completed my patch and I proposed it through this pull request

https://github.com/qgis/Quantum-GIS/pull/824

#9 - 2013-08-22 02:29 AM - René-Luc ReLuc

- Assignee changed from René-Luc ReLuc to Radim Blazek

Hi Radim,

I assigne this issue to you for reviewing my patch.

Marco wrote that you did a lot of work on composer legend.

Regards,

#10 - 2013-08-22 06:15 AM - Radim Blazek

I am offline until September 3, please ask someone else to apply the patch.

#11 - 2013-08-22 06:18 AM - Marco Hugentobler

- Assignee changed from Radim Blazek to Marco Hugentobler

Ok, in that case the ticket is assigned to me.

#12 - 2013-08-22 09:01 AM - Marco Hugentobler

- Status changed from Open to Closed

The changes are fine and the patch is applied in master branch. Thanks rldhont for fixing this issue!

#13 - 2013-09-03 04:05 AM - Lene Fischer
I have just downloaded weekly (03-09-13) Still the same problem. Is the correction not in the weekly yet?

Regards

Lene Fischer

#14 - 2013-09-03 04:27 AM - Giovanni Manghi

Lene Fischer wrote:

I have just downloaded weekly (03-09-13) Still the same problem. Is the correction not in the weekly yet?

Regards

Lene Fischer

it works fine here on Linux.

#15 - 2013-09-03 04:40 AM - Salvatore Larosa

Hi Lene,

Which is the revision code ?

The fix has been introduced in commit:7f8b259, so I think the last weekly should include that fix.

#16 - 2013-09-03 05:07 AM - René-Luc ReLuc

I've tested a today compliation on Ubuntu, qgis is named fef175b, and it works.

Files

12.png 234 KB 2013-08-15 Giovanni Manghi

22.png 235 KB 2013-08-15 Giovanni Manghi

11.png 176 KB 2013-08-15 Giovanni Manghi

2025-04-27 4/4


